;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Brightness Gradient Bottom
;by Ice Man
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	lorom				;\ ROM is LoRom
	header				;| and has a header
	org $228000			;/ Address to insert code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;RATS Tag Macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
	db "STAR"
	dw RATS_Endcode<id>-RATS_Startcode<id>
	dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF
RATS_Startcode<id>:
endmacro

macro RATS_end(id)
RATS_Endcode<id>:
endmacro

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HDMA Channel Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

%RATS_start(0)
	REP #$20			;\ Set processor 16 bit
	LDA #$0000			;| $4350 = $2100
	STA $4350			;| $4351 = Mode 00
	LDA #Gradient		;| Get gradient pointer
	STA $4352			;| low and high byte
	PHK					;| Get bank
	PLY					;| 
	STY $4354			;| Store to address bank
	SEP #$20			;/ Set processor 8 bit

	LDA #$20			;\ Enable HDMA
	TSB $0D9F			;| on channel 5
	RTL 				;/ Return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Table Settings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Gradient:
	db $80,$0F
	db $10,$0F
	db $08,$0E
	db $08,$0D
	db $08,$0C
	db $08,$0B
	db $08,$0A
	db $08,$09
	db $08,$08
	db $08,$07
	db $08,$06
	db $00
%RATS_end(0)