header
lorom

;Slope Pass Glitch Fix 2.1 by lolcats439
;This patch fixes the glitch that lets Mario pass through slopes by flying/jumping/swimming through them at a shallow angle.

;The actual fix is a single hex edit, but there's a side effect, it then doesn't let you jump up through a slope normally, it will stick you to it and zero your y speed, which is annoying and probably the reason Nintendo made the code only run if moving up in the first place. This patch works around that by not running the slope assist code when Mario is moving at a shallower angle than the slope itself, so you can jump up through it but not glitch under it.

;This is backwards compatible with the old version, you don't have to remove it first if you have it.

!FREESPACE = $168327 ; change to freespace


org $00EE87    ;\ fix the glitch
db $80         ;/

org $00EED1    ;\ Hijack code and JMP to custom code
JMP.l FixSideEffect ;/
NOP


org !FREESPACE
!CodeSize = CodeEnd-CodeStart ;\ 
RATS:                 ;| Write RATS tag to
db "STAR"             ;| prevent other programs
dw !CodeSize-$01      ;| from overwriting this 
dw !CodeSize-$01^$FFFF;/ code!

CodeStart:
FixSideEffect: 
LDA $00               ;\ use $00 as scratch RAM
PHA                   ;|
PHX                   ;/
LDA $7D               ;\ if Mario moving down, return
BPL Return            ;/
TYX                   ;\ Load what type of slope this is
LDA $00E53D,x         ;/
CMP #$00              ;\ if not on a slope, return
BEQ Return            ;/
AND #$80              ;\ if Mario moving opposite the direction the slope faces, 
STA $00               ;| return
LDA $7B               ;|
BEQ DontStickToSlope  ;|
AND #$80              ;|
CMP $00               ;|
BEQ DontStickToSlope  ;/
LDA $00E53D,x         ;\ store slope type as positive number to X
BPL Skip1             ;|
EOR #$FF              ;|
INC A                 ;|
Skip1:                ;|
TAX                   ;/
LDA $7D               ;\ Load y-speed, flip it to positive and store it to $00
EOR #$FF              ;|
STA $00               ;/
LDA $7B               ;\ Load x-speed, flip it to positive
BPL Skip2             ;|
EOR #$FF              ;|
Skip2:                ;/
CPX #$02              ;\ Normalize the ratio of x-speed:y-speed to assume a 45 degree angle
BEQ Normal            ;| for all slopes to simplify calculation
CPX #$03              ;|
BEQ Compare           ;|
CPX #$04              ;|
BEQ VerySteep         ;|
LSR A                 ;|
Normal:               ;|
LSR A                 ;|
BRA Compare           ;|
VerySteep:            ;|
LSR $00               ;/
Compare:              ;\ if normalized x/y speed less than x speed, return
CMP $00               ;| Mario is moving at a shallower angle than the slope
BCS Return            ;/ so stick him to it
DontStickToSlope:
PLX                   ;\ restore value of $00 and X
PLA                   ;|
STA $00               ;/
LDA #$00              ;\ Zero A, X, and Y before skipping code
LDX #$00              ;|
LDY #$00              ;|
JMP.l $00EF98         ;| jump to the RTS at the end of the codepath
Return:               ;/
PLX                   ;\ restore value of $00 and X
PLA                   ;|
STA $00               ;/
INC $13EF             ;\ restore overwritten code
LDA $96               ;|
JMP.l $00EED6         ;/ jump to the line right after the LDA $96
CodeEnd:



