import os
import re
import sys
import shutil

def end():
  input("Press enter to exit. . .")
  sys.exit()
  
xkas_patch = input("Patch name:\n")   # Get the patch name

if os.path.isfile(xkas_patch) is False: # Check if the file exists
  print ("Error: File does not exist.")
  end()
  
if os.path.getsize(xkas_patch) == 0:  # If the file ie empty don't even waste our time
  print ("Error: File is empty.")
  end()
  
fix = open(xkas_patch, "r") # Open file for reading
out = open("out.asm", "w") # Write to file

line = fix.readlines() # Get file into a list



n = 0

while n < len(line):

  if re.match('^[^;]*[Jj][Mm][Pp]\.[Ll]\s', line[n]) is not None: # JMP.l
    line[n] = re.sub(r'[Jj][Mm][Pp]\.[Ll]', r'JML', line[n]);
    n = n-3;
    
  if re.match('^[^;]*[Jj][Ss][Rr]\.[Ll]\s', line[n]) is not None: # JSR.l
    line[n] = re.sub(r'[Jj][Ss][Rr]\.[Ll]', r'JSL', line[n]); 
    n = n-3;
  
  if re.search('PLB', str(line)) is not None: # Change LDAs that call tables to LDA.l if it messes up the DBR
    line[n] = re.sub(r'LDA ([^$|#])', r'LDA.l \1', line[n])
  
  if re.match('^[^;]*[Oo][Rr][Gg]\s', line[n]) is not None: # Look for orgs
    a = n+1
    while a < len(line):  # See if there is a RATS tag below us if so this must be the freespace org
      
      line[a] = re.sub(r'([Jj][Mm|Ss][Ll].+)', r'autoclean \1', line[a])  # autoclean JML/JSLs
      
      if re.match('^[^;]*[Oo][Rr][Gg]', line[a]) is not None:   # If we find a org below us thats not right!
        break
      if re.match('^[^;]*db "STAR"', line[a]) is not None:  # Look for RATS tag
        
        badspace = re.sub(r'org (!.+)\n', r'\1', line[n])
        label = re.sub(r'dw[^-]+-([^-]+)-.+\n', r'\1', line[a+1])
        
        line[a] = ''
        line[a+1] = ''
        line[a+2] = ''
        
        i = 0       # Replace things that use a freespace define
        while i < len(line):
          if re.search(badspace, line[i]) is not None:
              if re.search('=', line[i]) is None:
                line[i] = re.sub(badspace, label, line[i])
          i = i+1
          
        if re.search('PLB', str(line)) is None:
          line[n] = 'freedata\n'  # Use freedata if the code doesn't messup the DBR
        else:
          line[n] = 'freecode\n'
        break
      a = a+1 

  n = n+1 # Go to next line

n = 0   # loop and write out to file
while n < len(line):
  out.write(line[n])
  n = n+1
print ("Done!")
end()

